Index: /greenstone3/branches/customizingGreenstone3/gs3-setup.sh
===================================================================
--- /greenstone3/branches/customizingGreenstone3/gs3-setup.sh	(revision 15190)
+++ /greenstone3/branches/customizingGreenstone3/gs3-setup.sh	(revision 15191)
@@ -2,131 +2,169 @@
 # this should work under ash, bash, zsh, ksh, sh style shells.
 
-# make sure we are sourced, and not run
+#the purpose of this file is to check/set up the environment for greenstone3
+#sorts out
+#	- gsdl3home
+#	- java
 
-if test "$0" != "`echo $0 | sed s/gs3-setup\.sh//`" ; then
-# if $0 contains "gs3-setup.sh" we've been run... $0 is shellname if sourced.
-# One exception is zsh has an option to set it temporarily to the script name
-  if test -z "$ZSH_NAME" ; then
-  # we aren't using zsh
-  gsdl_not_sourced=true
-  fi
-fi
-
-if test -n "$gsdl_not_sourced" ; then
-  echo "	Error: Make sure you source this script, not execute it. Eg:"
-  echo "		$ source gs3-setup.sh"
-  echo "	or"
-  echo "		$ . ./gs3-setup.sh"
-  echo "	not"
-  echo "		$ ./gs3-setup.sh"
-  unset gsdl_not_sourced
-  exit 1
-fi
-
-if test ! -f gs3-setup.sh ; then
-  echo "You must source the script from within the Greenstone home directory"
-  exit 1
-fi
-
-GSDL3SRCHOME=`pwd`
-GSDL3HOME=$GSDL3SRCHOME/web
-export GSDL3HOME
-export GSDL3SRCHOME
-GSDLOS=`uname -s | tr 'ABCDEFGHIJKLMNOPQRSTUVWXYZ' 'abcdefghijklmnopqrstuvwxyz'`
-# check for running bash under cygwin
-if test "`echo $GSDLOS | sed 's/cygwin//'`" != "$GSDLOS" ; then
-    GSDLOS=windows
-fi
-export GSDLOS
-
-#change this if external tomcat
-TOMCAT_HOME=$GSDL3SRCHOME/packages/tomcat
-
-PATH=$GSDL3SRCHOME/bin/script:$GSDL3SRCHOME/bin:$PATH
-export PATH
-MANPATH=$MANPATH:$GSDL3SRCHOME/doc/man
-export MANPATH
-
-CLASSPATH=$GSDL3HOME/WEB-INF/classes:$GSDL3SRCHOME/resources/java:$CLASSPATH
-for JARFILE in $GSDL3SRCHOME/*.jar; do
-    CLASSPATH=$CLASSPATH:$JARFILE
-done
-for JARFILE in $GSDL3SRCHOME/lib/jni/*.jar; do
-    CLASSPATH=$CLASSPATH:$JARFILE
-done
-for JARFILE in $GSDL3HOME/WEB-INF/lib/*.jar; do
-    CLASSPATH=$CLASSPATH:$JARFILE
-done
-for JARFILE in $TOMCAT_HOME/common/endorsed/*.jar; do
-    CLASSPATH=$CLASSPATH:$JARFILE
-done    
-for JARFILE in $GSDL3SRCHOME/build/*.jar; do
-    CLASSPATH=$CLASSPATH:$JARFILE
-done
-
-export CLASSPATH
-
-LD_LIBRARY_PATH=$LD_LIBRARY_PATH:$GSDL3SRCHOME/lib/jni
-export LD_LIBRARY_PATH
-## for mac
-DYLD_LIBRARY_PATH=$DYLD_LIBRARY_PATH:$GSDL3SRCHOME/lib/jni
-export DYLD_LIBRARY_PATH
+java_min_version=1.5.0_00
 
 
-# see if we can find java
-java="java"
-jfound=1
-jok=1
-# if JAVAHOME or JAVA_HOME is set we'll use it to determine where java lives, otherwise
-#  we just hope it's on the search path
-if [ "$JAVA_HOME" != "" ] ; then
-    java="$JAVA_HOME/bin/java"
-elif [ "$JAVAHOME" != "" ] ; then
-    java="$JAVAHOME/bin/java"
-    export JAVA_HOME=$JAVAHOME
-else
-    java=`which java 2> /dev/null`
-    if [ ! -x "$java" ]; then
-	echo "Failed to locate Java. You must install a java runtime environment"
-	echo "(version 1.4 or greater) before installing Greenstone 3."
-	jfound=0
-	jok=0
-    else
-	export JAVA_HOME=`echo $java | sed -n 's/[\\\/]bin[\\\/]java$//p'`
-    fi
-fi
-if [ $jfound -eq 1 ]; then
-    javaversion=`$java -version 2>&1 | sed -n 's/^java version \"\(.*\)\"/\1/p'`
-    jvmajor=`echo $javaversion | sed -n 's/^\([0-9]*\).*$/\1/p'`
-    jvminor=`echo $javaversion | sed -n 's/^[0-9]*\.\([0-9]*\).*$/\1/p'`
-    
-    if [ $jvmajor -lt 1 ] ; then
-	jok=0
-    fi
-    if [ $jvmajor -eq 1 ] && [ $jvminor -lt 4 ] ; then
-	jok=0
-    fi
-fi
+function testSource(){
 
-if [ $jfound -eq 1 ] && [ $jok -eq 0 ] ; then
-    echo "The version of the java runtime environment you have installed is too"
-    echo "old to run Greenstone 3. Please install a new version of the JRE (version"
-    echo "1.4 or newer) and rerun this installation."
-else
-    echo "Your environment has successfully been set up to run Greenstone3"
-fi
+  if test "$0" != "`echo $0 | sed s/gs3-setup\.sh//`" ; then
+  # if $0 contains "gs3-setup.sh" we've been run... $0 is shellname if sourced.
+  # One exception is zsh has an option to set it temporarily to the script name
+    if test -z "$ZSH_NAME" ; then
+    # we aren't using zsh
+     gsdl_not_sourced=true
+   fi 
+  fi
 
-#do we need to check for perl???
-# make sure perl is ok
-#perl=`which perl 2> /dev/null`
-# echo "perl: $perl"
-#if [ ! -x "$perl" ] ; then
-#    echo "Greenstone 3 requires perl in order to operate but this installation"
-#    echo "could not detect perl on your system. Please ensure that perl is installed"
-#    echo "and is on your search path then rerun this installation script."
-#    exit 1
-#fi
+  if test -n "$gsdl_not_sourced" ; then
+     echo "	Error: Make sure you source this script, not execute it. Eg:"
+     echo "		$ source gs3-setup.sh"
+     echo "	or"
+     echo "		$ . gs3-setup.sh"
+     echo "	not"
+     echo "		$ ./gs3-setup.sh"
+     unset gsdl_not_sourced
+     exit 1
+  fi
+
+  if test ! -f gs3-setup.sh ; then
+    echo "You must source the script from within the Greenstone home directory"
+    exit 1
+  fi
+
+}
+
+function setGS3ENV() {
+
+	echo "Setting up your environment for Greenstone3"
+	## main greenstone environment variables ##
+	GSDL3SRCHOME=`pwd`
+	GSDL3HOME=$GSDL3SRCHOME/web
+	export GSDL3HOME
+	export GSDL3SRCHOME
+
+	GSDLOS=`uname -s | tr 'ABCDEFGHIJKLMNOPQRSTUVWXYZ' 'abcdefghijklmnopqrstuvwxyz'`
+	# check for running bash under cygwin
+	if test "`echo $GSDLOS | sed 's/cygwin//'`" != "$GSDLOS" ; then
+		GSDLOS=windows
+	fi 
+	export GSDLOS
+	echo "  - Exported GSDL3HOME, GSDL3SRCHOME and GSDLOS"
+
+	#change this if external tomcat
+	TOMCAT_HOME=$GSDL3SRCHOME/packages/tomcat
 
 
+	## adjustments to users (existing) environment ##
 
+	#PATH
+	if [ `isinpath "$PATH" "$GSDL3SRCHOME/bin"` == "false" ]; then
+		PATH=$GSDL3SRCHOME/bin/script:$GSDL3SRCHOME/bin:$PATH
+		export PATH
+		MANPATH=$MANPATH:$GSDL3SRCHOME/doc/man
+		export MANPATH
+		echo "  - Adjusted PATH"
+	else
+		echo "  - PATH already correct"
+	fi
 
+	#CLASSPATH
+	if [ `isinpath "$CLASSPATH" "$GSDL3HOME/WEB-INF/classes"` == "false" ]; then
+		CLASSPATH=$GSDL3HOME/WEB-INF/classes:$GSDL3SRCHOME/resources/java:$CLASSPATH
+		for JARFILE in $GSDL3SRCHOME/*.jar; do
+			CLASSPATH=$CLASSPATH:$JARFILE
+		done
+		for JARFILE in $GSDL3SRCHOME/lib/jni/*.jar; do
+			CLASSPATH=$CLASSPATH:$JARFILE
+		done
+		for JARFILE in $GSDL3HOME/WEB-INF/lib/*.jar; do
+			CLASSPATH=$CLASSPATH:$JARFILE
+		done
+		for JARFILE in $TOMCAT_HOME/common/endorsed/*.jar; do
+			CLASSPATH=$CLASSPATH:$JARFILE
+		done    
+		for JARFILE in $GSDL3SRCHOME/build/*.jar; do
+			CLASSPATH=$CLASSPATH:$JARFILE
+		done
+		export CLASSPATH
+		echo "  - Adjusted CLASSPATH"
+	else
+		echo "  - CLASSPATH already correct"
+	fi
+
+	#LD_LIBRARY_PATH
+	if [ `isinpath "$LD_LIBRARY_PATH" "$GSDL3SRCHOME/lib/jni"` == "false" ]; then
+		LD_LIBRARY_PATH=$LD_LIBRARY_PATH:$GSDL3SRCHOME/lib/jni
+		export LD_LIBRARY_PATH
+		DYLD_LIBRARY_PATH=$DYLD_LIBRARY_PATH:$GSDL3SRCHOME/lib/jni
+		export DYLD_LIBRARY_PATH
+		echo "  - Adjusted LD_LIBRARY_PATH"
+	else
+		echo "  - LD_LIBRARY_PATH already correct"
+	fi
+
+	#ant
+	which ant &> /dev/null
+	if [ "$?" != "0" ]; then
+			ANT_HOME=$GSDL3SRCHOME/packages/ant
+			PATH=$ANT_HOME/bin:$PATH
+		echo "  - Setup ant"
+	else
+		echo "  - Ant already setup"
+	fi
+
+	echo
+}
+
+function checkJava() {
+	echo "Checking Java"
+
+  bin/search4j -m $java_min_version &> /dev/null
+  if [ "$?" != "0" ]; then
+
+		#java is not set up already
+	  bin/search4j -m $java_min_version -h packages/jre &> /dev/null
+	  if [ "$?" == "0" ]; then
+			#bundled java exists, set up
+			export JAVA_HOME=`pwd`/packages/jre
+  		echo "  - Exported JAVA_HOME to point to bundled java"
+		else
+			#no java exists
+	  	echo "  - Failed to locate java ($java_min_version or greater)"
+			bin/search4j &> /dev/null; if [ "$?" == "0" ]; then echo "  (It looks like you hava java but it's too old)"; fi
+			echo "  - Please set JAVA_HOME or JRE_HOME to point to an appropriate java"
+  		echo "    And add JAVA_HOME/bin or JRE_HOME/bin to your PATH"
+		fi
+
+	else
+
+		#java is already set up
+		echo "  - Found java at: `bin/search4j -m $java_min_version`"
+
+  fi
+	echo
+}
+
+function pauseAndExit(){
+ echo -n "Please press any key to continue... "
+ read 
+}
+
+function isinpath() {
+	for file in `echo $1 | sed 's/:/ /g'`; do
+		if [ "$file" == "$2" ]; then
+			echo true
+			return
+		fi
+	done
+	echo false
+}
+
+echo
+testSource
+setGS3ENV
+checkJava
Index: /greenstone3/branches/customizingGreenstone3/resources/java/global.properties.in
===================================================================
--- /greenstone3/branches/customizingGreenstone3/resources/java/global.properties.in	(revision 15190)
+++ /greenstone3/branches/customizingGreenstone3/resources/java/global.properties.in	(revision 15191)
@@ -1,5 +1,5 @@
 ## greenstone home
 gsdl3.home=@gsdl3home@
-gsdl3.version=@gsdl3version@
+gsdl3.version=S20080214
 
 # tomcat info
Index: /greenstone3/branches/customizingGreenstone3/resources/tomcat/setclasspath.bat
===================================================================
--- /greenstone3/branches/customizingGreenstone3/resources/tomcat/setclasspath.bat	(revision 15190)
+++ /greenstone3/branches/customizingGreenstone3/resources/tomcat/setclasspath.bat	(revision 15191)
@@ -6,14 +6,26 @@
 
 rem Make sure prerequisite environment variables are set
-if not "%JAVA_HOME%" == "" goto gotJavaHome
-echo The JAVA_HOME environment variable is not defined
-echo This environment variable is needed to run this program
+if not "%JAVA_HOME%" == "" goto gotJdkHome
+if not "%JRE_HOME%" == "" goto gotJreHome
+echo Neither the JAVA_HOME nor the JRE_HOME environment variable is defined
+echo At least one of these environment variable is needed to run this program
 goto exit
-:gotJavaHome
+
+:gotJreHome
+if not exist "%JRE_HOME%\bin\java.exe" goto noJavaHome
+if not exist "%JRE_HOME%\bin\javaw.exe" goto noJavaHome
+if not ""%1"" == ""debug"" goto okJavaHome
+echo JAVA_HOME should point to a JDK in order to run in debug mode.
+goto exit
+
+:gotJdkHome
 if not exist "%JAVA_HOME%\bin\java.exe" goto noJavaHome
 if not exist "%JAVA_HOME%\bin\javaw.exe" goto noJavaHome
 if not exist "%JAVA_HOME%\bin\jdb.exe" goto noJavaHome
 if not exist "%JAVA_HOME%\bin\javac.exe" goto noJavaHome
+if not "%JRE_HOME%" == "" goto okJavaHome
+set JRE_HOME=%JAVA_HOME%
 goto okJavaHome
+
 :noJavaHome
 echo The JAVA_HOME environment variable is not defined correctly
@@ -45,6 +57,6 @@
 rem Note that NT requires a window name argument when using start.
 rem Also note the quoting as JAVA_HOME may contain spaces.
-set _RUNJAVA="%JAVA_HOME%\bin\java"
-set _RUNJAVAW="%JAVA_HOME%\bin\javaw"
+set _RUNJAVA="%JRE_HOME%\bin\java"
+set _RUNJAVAW="%JRE_HOME%\bin\javaw"
 set _RUNJDB="%JAVA_HOME%\bin\jdb"
 set _RUNJAVAC="%JAVA_HOME%\bin\javac"
Index: /greenstone3/branches/customizingGreenstone3/resources/tomcat/setclasspath.sh
===================================================================
--- /greenstone3/branches/customizingGreenstone3/resources/tomcat/setclasspath.sh	(revision 15190)
+++ /greenstone3/branches/customizingGreenstone3/resources/tomcat/setclasspath.sh	(revision 15191)
@@ -7,12 +7,16 @@
 
 # First clear out the user classpath
-# gs3 - we need to set classpath
 CLASSPATH=$CLASSPATH
 
 # Make sure prerequisite environment variables are set
 if [ -z "$JAVA_HOME" -a -z "$JRE_HOME" ]; then
-  echo "Neither the JAVA_HOME nor the JRE_HOME environment variable is defined"
-  echo "At least one of these environment variable is needed to run this program"
-  exit 1
+  # Bugzilla 37284
+  if $darwin && [ -d "/System/Library/Frameworks/JavaVM.framework/Versions/1.5/Home" ]; then
+    export JAVA_HOME="/System/Library/Frameworks/JavaVM.framework/Versions/1.5/Home"
+  else
+    echo "Neither the JAVA_HOME nor the JRE_HOME environment variable is defined"
+    echo "At least one of these environment variable is needed to run this program"
+    exit 1
+  fi
 fi
 if [ -z "$JAVA_HOME" -a "$1" = "debug" ]; then
Index: /greenstone3/branches/customizingGreenstone3/src/java/org/greenstone/gsdl3/action/QueryAction.java
===================================================================
--- /greenstone3/branches/customizingGreenstone3/src/java/org/greenstone/gsdl3/action/QueryAction.java	(revision 15190)
+++ /greenstone3/branches/customizingGreenstone3/src/java/org/greenstone/gsdl3/action/QueryAction.java	(revision 15191)
@@ -107,4 +107,6 @@
 	mr_query_message.appendChild(format_request);
 
+	logger.info(GSXML.xmlNodeToString(mr_query_message));
+
 	// do the query
        	Element mr_query_response = (Element)this.mr.process(mr_query_message);
@@ -207,10 +209,11 @@
 	// check the hits_per_page param - is it a service param??
 	String hits_pp = (String) service_params.get("hitsPerPage");
-	if (hits_pp != null) {
-	    // the service is doing the paging, so we want to display all of the returned docs
-	    return (Element)this.doc.importNode(orig_doc_list, true);
-	}
-	
-	hits_pp = (String)params.get("hitsPerPage");
+	if (hits_pp == null) {
+	    // the service is doing the paging, so we want to display all of the returned docs(???)
+	//    return (Element)this.doc.importNode(orig_doc_list, true);
+	// try hitsPerPage in the globle param
+	     hits_pp = (String)params.get("hitsPerPage");
+        }
+	
 	int hits = 20;
 	if (hits_pp != null && !hits_pp.equals("")) {
@@ -235,5 +238,10 @@
 	// now we need our own doc list
 	Element result_list = this.doc.createElement(GSXML.DOC_NODE_ELEM + GSXML.LIST_MODIFIER);
-	String start_p = (String)params.get("startPage");
+	
+	String start_p = (String) service_params.get("startPage");
+	if(start_p == null){
+	    start_p = (String)params.get("startPage");
+	}
+
 	int start = 1;
 	if (start_p != null && !start_p.equals("")) {
